 /*
		debugging functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Complex.h"

#ifndef _DEBUG_H_
#define _DEBUG_H_

/* push expression to which pointer in array is pointing */
void PushArrExpr(EStackIndex arr[],
	unsigned short i); 

/* push contents on stack as matrix to top of stack 
["NAME_OF_TAG CODE_OF_TAG" VALUE_OF_EXPR;...] 
theoretically we could save a lot of memory by removing the arrays of strings 
but when using get_key_ptr there are a lot of tags missing (this affects 
primary, secondary and command tags also) */
void PushStackAsMat(void);  

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

/* prompt user for string */
void InputStr(char *prompt,
	char buf[],
	unsigned short len);

/////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifdef DEBUG

/* display expression array */
void ExprArrPause(EStackIndex arr[], 
	unsigned short len);

/* display expression matrix */
void ExprMatPause(EStackIndex *mat, 
	unsigned short rows,
	unsigned short cols);

/* display float array */
void FloatArrPause(double arr[], 
	unsigned short len);

/* display float matrix */
void FloatMatPause(double *mat, 
	unsigned short rows,
	unsigned short cols);

/* display complex float array */
void CFloatArrPause(Complex arr[], 
	unsigned short len);

/* display complex float matrix */
void CFloatMatPause(Complex *mat, 
	unsigned short rows,
	unsigned short cols);

/* dispaly name of tag */
void TagPause(EStackIndex i);

/* display SYM_ENTRY */
void SYM_ENTRYPause(SYM_ENTRY se);

#endif

#endif

