/*
		convolution by FFT
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>
#include "FFT.h"
#include "FFTConv.h"
#include "Matrix.h"
#include "Memory.h"
#include "Real.h"
#include "Stack.h"

/* convolution by FFT
This may be slow when length of x and h are quite different
(in that case the overlap-add method should give better performance but adds algorithmic complexity also) 
for 64*64 convolution this takes longer than conovolution 
for 256*256 it takes half the time of convolution 
??? the result is only 1/4 of the expected values */
/*void fconv(void)
{
    Access_AMS_Global_Variables;

    EStackIndex argptr = top_estack;
	volatile HANDLE xHdl, hHdl;
    Complex *xPtr;
    unsigned short lx, lh;

    CheckNumArgs (2);

    TRY
		lx = GetComplexFloatListArg (argptr, &xHdl);

        argptr = next_expression_index (argptr);

        lh = GetComplexFloatListArg (argptr, &hHdl);

		// perform convolution by FFT
		FFTConv(xHdl,
			lx,
			hHdl,
			lh);

        xPtr = HeapDeref (xHdl);
        
        push_complex_float_list (xPtr, CeilPow2 (lx + lh - 1));
    FINALLY
        HeapFreeIndir ((HANDLE *)&xHdl);
        HeapFreeIndir ((HANDLE *)&hHdl);
    ENDFINAL
}*/

/* convolution by FFT
(this is linear and not circular
Dereferencing x and h gives pointers to array of Complex
Result is in x, its original content is overwritten */
/*void FFTConv(HANDLE x,
	unsigned short lx,
	HANDLE h,
	unsigned short lh)
{
    //HANDLE xHdl, hHdl;
    Complex *xPtr, *hPtr;
    const unsigned short l = lx + lh - 1;

    // length of array holding linear convolution
    unsigned short lc = CeilPow2 (l);

    // pad signal and impulse response to length of convolution brought to next power of 2
	CPad  (x, lx, lc);
    CPad  (h, lh, lc);

    xPtr = HeapDeref  (x);
    hPtr = HeapDeref  (h);

    // covert from time domain to frequency domain
	FFT (xPtr, lc, FORWARD);
    FFT (hPtr, lc, FORWARD);

    // multiplication in FD is convolution in TD
	CMatMatMul (xPtr, hPtr, lc);
   
    // convert product in FD to TD again
    FFT (xPtr, lc, INVERSE);

    // result was padded to get length that is power of two
	if (lc > l) {
        // discard the elements after lx + lh  1
        HeapReallocThrow (x, l * sizeof (Complex));
    }
}*/
 
