/*
		ROM calls missing in tiams.h
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>

#ifndef _ROM_H_
#define _ROM_H_

#define MAX_HELP_STR 34
#define MAX_LST_LEN 2048

typedef struct {
	unsigned short Size; 
	Quantum *Expr;
} MULTI_EXPR; 

/* these Tags are missing 
according to TIGCC doc they have been introduced in AMS 2.08 */

#define ASECH_TAG	(50u)
#define ACSCH_TAG	(51u)
#define ACOTH_TAG	(52u)
#define SECH_TAG	(56u)
#define CSCH_TAG	(57u)
#define COTH_TAG	(58u)
#define ASEC_TAG	(62u)
#define ACSC_TAG	(63u)
#define ACOT_TAG	(64u)
#define SEC_TAG		(71u)
#define CSC_TAG		(72u)
#define COT_TAG		(73u)

/* these ROM calls are missing in timas.h */

// http://tict.ticalc.org/gcc4ti/doc/estack.html#get_list_indices (proto info from Lionel Deboux)
EStackIndex *tiamsapi_696(const EStackIndex *expr, unsigned short count, EStackIndex indices);
#define get_list_indices tiamsapi_696

// http://tict.ticalc.org/gcc4ti/doc/estack.html#get_matrix_indices
EStackIndex *tiamsapi_696(const EStackIndex *expr, unsigned short count, EStackIndex indices); // ???
#define get_matrix_indices tiamsapi_697

// http://tict.ticalc.org/gcc4ti/doc/estack.html#init_list_indices
EStackIndex *tiamsapi_698(EStackIndex *, const EStackIndex);
#define init_list_indices tiamsapi_698

// http://tict.ticalc.org/gcc4ti/doc/estack.html#init_matrix_indices
EStackIndex *tiamsapi_699(EStackIndex *, const EStackIndex);
#define init_matrix_indices tiamsapi_699

short tiamsapi_854(const EStackIndex);
#define cmd_input tiamsapi_854

short tiamsapi_855(const EStackIndex);
#define cmd_inputstr tiamsapi_855

short tiamsapi_721(EStackIndex, EStackIndex);
#define is_antisymmetric tiamsapi_721

short tiamsapi_732(EStackIndex, EStackIndex);
#define is_symmetric tiamsapi_732

void tiamsapi_875(EStackIndex);
#define cmd_pause tiamsapi_875

//#define cmd_randseed ({__need_in_use_bit;_rom_call(void,(CESI),380);})
void tiamsapi_896(EStackIndex);
#define cmd_randseed tiamsapi_896

/* the following functions are declared only to be able to pass their 
addresses as function pointers to wrapper functions in BE.c 
passing the addresses directly without the wrappers doesnt compile */
 
void cmdpause(EStackIndex i);

void cmdrandseed(EStackIndex i);

void cmdsorta(EStackIndex i);

void cmdsortd(EStackIndex i);

void fdeletew(char name[]);

Boolean isantisymmetricw(EStackIndex expr_ptr, EStackIndex var_ptr);

Boolean isconstantw(EStackIndex i);

Boolean isindependentofw(EStackIndex i, EStackIndex j);

Boolean isnegativew(EStackIndex i);

Boolean isnever0w(EStackIndex i);

Boolean ispositivew(EStackIndex i);

Boolean isrealw(EStackIndex i);

Boolean issymmetricw(EStackIndex expr_ptr, EStackIndex var_ptr);

Boolean isvariablew(EStackIndex i);

void pushpolydeginvarorkernelw(EStackIndex i, EStackIndex vi);

void sthelpmsgw(char str[]);

#endif
