/*
		search functions
		
    Copyright (C) 2013  Ralph Schenn with support from Kevin Kofler

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>

#ifndef _SEARCH_H_
#define _SEARCH_H_

/* check if array of handles to strings contains string 
return -1 if string was not found 
when string is found the index is returned */
//short ArrayContStr(HANDLE strArray[], short length, const char *str);

/* binary search
https://de.wikipedia.org/wiki/Bin%C3%A4re_Suche */
unsigned short BinSearch(EStackIndex list, 
	EStackIndex key);

/* search memory subblock in block 
this works for arbitrary content without the need for \0 termination 
case sensitive search */ 
const char *BlockContBlock(const char *memstart,
	const char *string, 
	unsigned short memsize, 
	unsigned short stringsize);

/* recursive string search (commands for loop) */
void RecStrSe(SYM_ENTRY *symptr, 
	char *str, 
	char numArgs, 
	char *folder,
	unsigned short *numVars);

/* recursive variable search (commands for loop) */
void RecVarSe(SYM_ENTRY *symptr, 
	char *str, 
	char numArgs, 
	char *folder,
	unsigned short *numVars);

/* recursive string or variable search */
void RecSearch(void (*funcPtr)(SYM_ENTRY *symptr, 
	char *str, 
	char numArgs, 
	char *folder, 
	unsigned short *numVars));

/* count number of occurences of val in array 
array must not be null-terminated */
//unsigned short CountChar(char array[], unsigned short length, char val);

#endif
