 /*
		string functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>

#ifndef _STRING_H_
#define _STRING_H_

/* check if s1 contains s2 
case insensitive version 
function is non-destructive 
caution: if you can avoid dynamic memory alloc and making copies of strings 
you will get much better performance (using strtolower and strstr) */
char * stristr (const char * s1, const char * s2);

/* convert string to lower case
dst == src: destructive conversion 
dst != src : nondestructive conversion 
memory allocation must be handled by the caller */
void strtolower(char *dst, char *src);

#endif 
                                       